<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: include/core/Event.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_3d69f64eaf81436fe2b22361382717e5.html">core</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">Event.hpp</div></div>
</div><!--header-->
<div class="contents">
<a href="Event_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="preprocessor">#include &lt;unordered_map&gt;</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span> </div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno"><a class="line" href="Event_8hpp.html#ac39733f708d7eb4f35b90ae36c196e89">    5</a></span><span class="preprocessor">#define BIT_FIELD(x) (1 &lt;&lt; x)</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span> </div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacegg.html">gg</a></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span>{</div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="keyword">class </span>EventDispatcher;</div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span> </div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno"><a class="line" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122">   11</a></span><span class="keyword">enum class</span> <a class="code hl_enumeration" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122">EventType</a> {</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span>    <a class="code hl_enumvalue" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a6adf97f83acf6453d4a6a4b1070f3754">None</a> = 0,</div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span>    <span class="comment">// Window Events</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>    <a class="code hl_enumvalue" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a9f8f27bff2915738c4fe1b970e12f89c">WindowResize</a>,</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span>    <a class="code hl_enumvalue" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122ac984201d37197ab297a14d19efee4b07">WindowClose</a>,</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>    <span class="comment">// Input Events</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span>    <a class="code hl_enumvalue" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122ac2770ad109c8063ce69a3608a9a16c08">MouseMoved</a>,</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span>    <a class="code hl_enumvalue" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a0c727a782f5704f3020d6831cfcc1ed1">MousePressed</a>,</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span>    <a class="code hl_enumvalue" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a33bd071d891ee2f9147b76a58d18d554">MouseReleased</a>,</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span>    <a class="code hl_enumvalue" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a6360c775f2c9e4b01a927410726dff09">KeyboardPressed</a>,</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>    <a class="code hl_enumvalue" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a32b46f19c07697307b7935a700c82b8f">KeyboardReleased</a>,</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>    <span class="comment">// Scene events</span></div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>    <a class="code hl_enumvalue" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a9c130e95620950534eee656031fc6a12">ButtonClicked</a>,</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>    <a class="code hl_enumvalue" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122ad7581f38211da778a489922e48b6d78c">ToggleButtonClicked</a>,</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span>    <a class="code hl_enumvalue" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a4dd32204c0f6c88a76b95591fffc7ee1">TextInserted</a>,</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>    <span class="comment">// Time events</span></div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>    <a class="code hl_class" href="classgg_1_1TimePassed.html">TimePassed</a>,</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span>    <a class="code hl_enumvalue" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122abe3914d0f55bc3f12bdefcf7fb799bab">TestEvent</a></div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>};</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno"><a class="line" href="namespacegg.html#a98db2e09803bf503c02d952e6a8840f4">   31</a></span><span class="keyword">enum class</span> <a class="code hl_enumeration" href="namespacegg.html#a98db2e09803bf503c02d952e6a8840f4">EventCategory</a> {</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>    <a class="code hl_enumvalue" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a6adf97f83acf6453d4a6a4b1070f3754">None</a> = 0,</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>    <a class="code hl_enumvalue" href="namespacegg.html#a98db2e09803bf503c02d952e6a8840f4a6e700fb918edc200030d12664aca3b6b">EventBuilding</a> = <a class="code hl_define" href="Event_8hpp.html#ac39733f708d7eb4f35b90ae36c196e89">BIT_FIELD</a>(0),   <span class="comment">// we use bit field to specify events that</span></div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>    <a class="code hl_enumvalue" href="namespacegg.html#a98db2e09803bf503c02d952e6a8840f4a0a6e5fa84fb8c3d2c01f29f51f7d56ae">EventDestroying</a> = <a class="code hl_define" href="Event_8hpp.html#ac39733f708d7eb4f35b90ae36c196e89">BIT_FIELD</a>(1), <span class="comment">// can belong to multiple categories</span></div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    <a class="code hl_enumvalue" href="namespacegg.html#a98db2e09803bf503c02d952e6a8840f4a6fa566508cafa0ce4b09501f0c6946f1">EventTerraforming</a> = <a class="code hl_define" href="Event_8hpp.html#ac39733f708d7eb4f35b90ae36c196e89">BIT_FIELD</a>(2),</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>    <a class="code hl_enumvalue" href="namespacegg.html#a98db2e09803bf503c02d952e6a8840f4ac89686a387d2b12b3c729ce35a0bcb5b">Window</a> = <a class="code hl_define" href="Event_8hpp.html#ac39733f708d7eb4f35b90ae36c196e89">BIT_FIELD</a>(3)</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span> </div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>};</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span> </div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno"><a class="line" href="classgg_1_1IEvent.html">   40</a></span><span class="keyword">class </span><a class="code hl_class" href="classgg_1_1IEvent.html">IEvent</a></div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>{</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno"><a class="line" href="classgg_1_1IEvent.html#acbf64dbf915a0e0d66bce214266f8ac4">   43</a></span>    <span class="keyword">virtual</span> <a class="code hl_function" href="classgg_1_1IEvent.html#acbf64dbf915a0e0d66bce214266f8ac4">~IEvent</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span> </div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno"><a class="line" href="classgg_1_1IEvent.html#a0154647492980621230ab6cdc3b3080b">   45</a></span>    [[nodiscard]] <span class="keyword">inline</span> <span class="keyword">virtual</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1IEvent.html#a0154647492980621230ab6cdc3b3080b">GetEventType</a>() const -&gt; <a class="code hl_enumeration" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122">EventType</a> = 0;</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>    <span class="comment">// virtual EventCategory GetEventCategoryFlags() const = 0;</span></div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span> </div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>    <span class="comment">// inline bool IsInCategory(EventCategory category) const</span></div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>    <span class="comment">//{</span></div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>    <span class="comment">//  // operator &#39;&amp;&#39; is not defined for EventCategory class so this</span></div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>    <span class="comment">// conversion is needed     return</span></div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>    <span class="comment">// static_cast&lt;long&gt;(GetEventCategoryFlags()) &amp; static_cast&lt;long&gt;(category);</span></div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>    <span class="comment">//}</span></div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>  protected:</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno"><a class="line" href="classgg_1_1IEvent.html#a0ce169bdd9bd94235a58670a6e9d81cd">   55</a></span>    <a class="code hl_class" href="classgg_1_1IEvent.html">IEvent</a>() = default;</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>};</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span> </div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno"><a class="line" href="classgg_1_1IEventSubscriber.html">   58</a></span>class <a class="code hl_class" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a></div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>{</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno"><a class="line" href="classgg_1_1IEventSubscriber.html#a08d412b35e08386f265840cd3652c8fc">   61</a></span>    <a class="code hl_function" href="classgg_1_1IEventSubscriber.html#a08d412b35e08386f265840cd3652c8fc">IEventSubscriber</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span> </div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno"><a class="line" href="classgg_1_1IEventSubscriber.html#a574e684bfb29123ae250769873231cd8">   63</a></span>    <span class="keyword">virtual</span> <a class="code hl_function" href="classgg_1_1IEventSubscriber.html#a574e684bfb29123ae250769873231cd8">~IEventSubscriber</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno"><a class="line" href="classgg_1_1IEventSubscriber.html#ac8aebcb4316a65f73f794a924e5619ee">   64</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1IEventSubscriber.html#ac8aebcb4316a65f73f794a924e5619ee">operator==</a>(<span class="keyword">const</span> <a class="code hl_class" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a> &amp;) -&gt; bool;</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span> </div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno"><a class="line" href="classgg_1_1IEventSubscriber.html#a08c9dd34d285004445b619fe55a064f6">   66</a></span>    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1IEventSubscriber.html#a08c9dd34d285004445b619fe55a064f6">OnEvent</a>(<a class="code hl_class" href="classgg_1_1IEvent.html">IEvent</a> *e)</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>    {</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>        <a class="code hl_define" href="Logger_8hpp.html#a5735309bc12e817923d9bc2a28d95cf5">GG_INFO</a>(<span class="stringliteral">&quot;Implement OnEvent in your derived class!&quot;</span>);</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>    }</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span> </div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno"><a class="line" href="classgg_1_1IEventSubscriber.html#a961a23b00ee141313a4c8f7a505f3cb8">   71</a></span>    [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1IEventSubscriber.html#a961a23b00ee141313a4c8f7a505f3cb8">GetNumberOfSubscribedEvents</a>() const -&gt; <span class="keywordtype">size_t</span>;</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span> </div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno"><a class="line" href="classgg_1_1IEventSubscriber.html#ad78398900f7d14a9594e243e115e7ad0">   73</a></span>    <span class="keywordtype">void</span> IncrementNumberOfSubscribedEvents();</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span> </div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno"><a class="line" href="classgg_1_1IEventSubscriber.html#a87ad672a9db8b804deca81b7c4e6723f">   75</a></span>    <span class="keywordtype">void</span> DecrementNumberOfSubscribedEvents();</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span> </div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno"><a class="line" href="classgg_1_1IEventSubscriber.html#a44c244803f071939ab0822ec856903db">   77</a></span>    <span class="keywordtype">void</span> ResetNumberOfSubscribedEvents();</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span> </div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>  private:</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>    <span class="keywordtype">size_t</span> mNumOfSubscribedEvents = 0;</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>};</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>} <span class="comment">// namespace gg</span></div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno"><a class="line" href="namespacestd.html">   83</a></span>namespace <a class="code hl_namespace" href="namespacestd.html">std</a></div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>{</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>}</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span> </div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacegg.html">gg</a></div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>{</div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno"><a class="line" href="classgg_1_1EventDispatcher.html">   89</a></span><span class="keyword">class </span><a class="code hl_class" href="classgg_1_1EventDispatcher.html">EventDispatcher</a></div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>{</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno"><a class="line" href="classgg_1_1EventDispatcher.html#ab0f8028199ca3b02d37f642ac24e6e53">   92</a></span>    <span class="keyword">static</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1EventDispatcher.html#ab0f8028199ca3b02d37f642ac24e6e53">GetInstance</a>() -&gt; <a class="code hl_class" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>    {</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>        <span class="keyword">static</span> <a class="code hl_class" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> sInstance;</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>        <span class="keywordflow">return</span> sInstance;</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>    }</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span> </div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>    <span class="comment">// should not need destructor as it will be alive during whole runtime</span></div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span> </div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>    <span class="comment">// better to keep deleted operators public (see Effective Modern C++)</span></div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno"><a class="line" href="classgg_1_1EventDispatcher.html#a87ff25ad98e9fa481e6f64247d7aba4d">  101</a></span>    <a class="code hl_function" href="classgg_1_1EventDispatcher.html#a87ff25ad98e9fa481e6f64247d7aba4d">EventDispatcher</a>(<a class="code hl_class" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;&amp;) = <span class="keyword">delete</span>;</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno"><a class="line" href="classgg_1_1EventDispatcher.html#a7b583685f6d4dd8685bab4f7c5e3e279">  102</a></span>    <a class="code hl_function" href="classgg_1_1EventDispatcher.html#a7b583685f6d4dd8685bab4f7c5e3e279">EventDispatcher</a>(<span class="keyword">const</span> <a class="code hl_class" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;) = <span class="keyword">delete</span>;</div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno"><a class="line" href="classgg_1_1EventDispatcher.html#ad509264c69cbbbace55964f563d7d0d8">  103</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1EventDispatcher.html#ad509264c69cbbbace55964f563d7d0d8">operator=</a>(<span class="keyword">const</span> <a class="code hl_class" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;) -&gt; <a class="code hl_class" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp; = <span class="keyword">delete</span>;</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno"><a class="line" href="classgg_1_1EventDispatcher.html#a7b6b1302a26315587a73a74ac8395c71">  104</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1EventDispatcher.html#a7b6b1302a26315587a73a74ac8395c71">operator=</a>(<a class="code hl_class" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;&amp;) -&gt; <a class="code hl_class" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp; = <span class="keyword">delete</span>;</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span> </div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno"><a class="line" href="classgg_1_1EventDispatcher.html#a25898f3f671cc2fcdb9ac2e5b5fd1a3e">  106</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1EventDispatcher.html#a25898f3f671cc2fcdb9ac2e5b5fd1a3e">Subscribe</a>(<a class="code hl_class" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a> *s, <span class="keyword">const</span> <a class="code hl_enumeration" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122">EventType</a> e);</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno"><a class="line" href="classgg_1_1EventDispatcher.html#aa2ac8a84c686abe1e1d1319e82221ed7">  107</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1EventDispatcher.html#aa2ac8a84c686abe1e1d1319e82221ed7">Unsubscribe</a>(<a class="code hl_class" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a> *s, <span class="keyword">const</span> <a class="code hl_enumeration" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122">EventType</a> e);</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>    <span class="comment">// could be a private method, but we want to allow subscriber to remove</span></div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>    <span class="comment">// itself in one go, instead only when it does not have any monitoring</span></div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>    <span class="comment">// events</span></div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno"><a class="line" href="classgg_1_1EventDispatcher.html#a7d3c833a67f1cde56f6f4ca2ed0a4fbd">  111</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1EventDispatcher.html#a7d3c833a67f1cde56f6f4ca2ed0a4fbd">RemoveSubscriber</a>(<a class="code hl_class" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a> *s);</div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span> </div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno"><a class="line" href="classgg_1_1EventDispatcher.html#ac0c4379683c748e569a9fa6be55bab55">  113</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1EventDispatcher.html#ac0c4379683c748e569a9fa6be55bab55">NotifySubscribers</a>(<a class="code hl_class" href="classgg_1_1IEvent.html">IEvent</a> *e);</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span> </div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno"><a class="line" href="classgg_1_1EventDispatcher.html#a7ad81d66b2f595f42de4e7841ef11044">  115</a></span>    <span class="keyword">static</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1EventDispatcher.html#a7ad81d66b2f595f42de4e7841ef11044">NumberOfSubscribers</a>() -&gt; int;</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno"><a class="line" href="classgg_1_1EventDispatcher.html#ab3245f7372c0d5384580f75c0ce2301b">  116</a></span>    <span class="keyword">friend</span> <span class="keywordtype">bool</span> <a class="code hl_friend" href="classgg_1_1EventDispatcher.html#ab3245f7372c0d5384580f75c0ce2301b">CheckSubscriberExistence</a>(<a class="code hl_class" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a>* e);</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span> </div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>  <span class="keyword">private</span>:</div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>    <a class="code hl_class" href="classgg_1_1EventDispatcher.html">EventDispatcher</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span> </div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>    <span class="comment">// Pointer on the first is required because we are dealing with an abstract</span></div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>    <span class="comment">// class Without it, map would assume that all our derived classes are this</span></div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>    <span class="comment">// abstract class</span></div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>    std::unordered_map&lt;IEventSubscriber *, std::vector&lt;EventType&gt;&gt;</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>        mSubscribers;</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>};</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span> </div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno"><a class="line" href="namespacegg.html#a03e8c24de531dd717d01d59ca2dc6f93">  128</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="namespacegg.html#a03e8c24de531dd717d01d59ca2dc6f93">CheckSubscriberExistence</a>(<a class="code hl_class" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a>* e);</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span> </div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>} <span class="comment">// namespace gg</span></div>
<div class="ttc" id="aEvent_8hpp_html_ac39733f708d7eb4f35b90ae36c196e89"><div class="ttname"><a href="Event_8hpp.html#ac39733f708d7eb4f35b90ae36c196e89">BIT_FIELD</a></div><div class="ttdeci">#define BIT_FIELD(x)</div><div class="ttdef"><b>Definition:</b> Event.hpp:5</div></div>
<div class="ttc" id="aLogger_8hpp_html_a5735309bc12e817923d9bc2a28d95cf5"><div class="ttname"><a href="Logger_8hpp.html#a5735309bc12e817923d9bc2a28d95cf5">GG_INFO</a></div><div class="ttdeci">#define GG_INFO(...)</div><div class="ttdef"><b>Definition:</b> Logger.hpp:31</div></div>
<div class="ttc" id="aclassgg_1_1EventDispatcher_html"><div class="ttname"><a href="classgg_1_1EventDispatcher.html">gg::EventDispatcher</a></div><div class="ttdef"><b>Definition:</b> Event.hpp:90</div></div>
<div class="ttc" id="aclassgg_1_1EventDispatcher_html_a25898f3f671cc2fcdb9ac2e5b5fd1a3e"><div class="ttname"><a href="classgg_1_1EventDispatcher.html#a25898f3f671cc2fcdb9ac2e5b5fd1a3e">gg::EventDispatcher::Subscribe</a></div><div class="ttdeci">static void Subscribe(IEventSubscriber *s, const EventType e)</div></div>
<div class="ttc" id="aclassgg_1_1EventDispatcher_html_a7ad81d66b2f595f42de4e7841ef11044"><div class="ttname"><a href="classgg_1_1EventDispatcher.html#a7ad81d66b2f595f42de4e7841ef11044">gg::EventDispatcher::NumberOfSubscribers</a></div><div class="ttdeci">static auto NumberOfSubscribers() -&gt; int</div></div>
<div class="ttc" id="aclassgg_1_1EventDispatcher_html_a7b583685f6d4dd8685bab4f7c5e3e279"><div class="ttname"><a href="classgg_1_1EventDispatcher.html#a7b583685f6d4dd8685bab4f7c5e3e279">gg::EventDispatcher::EventDispatcher</a></div><div class="ttdeci">EventDispatcher(const EventDispatcher &amp;)=delete</div></div>
<div class="ttc" id="aclassgg_1_1EventDispatcher_html_a7b6b1302a26315587a73a74ac8395c71"><div class="ttname"><a href="classgg_1_1EventDispatcher.html#a7b6b1302a26315587a73a74ac8395c71">gg::EventDispatcher::operator=</a></div><div class="ttdeci">auto operator=(EventDispatcher &amp;&amp;) -&gt; EventDispatcher &amp;=delete</div></div>
<div class="ttc" id="aclassgg_1_1EventDispatcher_html_a7d3c833a67f1cde56f6f4ca2ed0a4fbd"><div class="ttname"><a href="classgg_1_1EventDispatcher.html#a7d3c833a67f1cde56f6f4ca2ed0a4fbd">gg::EventDispatcher::RemoveSubscriber</a></div><div class="ttdeci">static void RemoveSubscriber(IEventSubscriber *s)</div></div>
<div class="ttc" id="aclassgg_1_1EventDispatcher_html_a87ff25ad98e9fa481e6f64247d7aba4d"><div class="ttname"><a href="classgg_1_1EventDispatcher.html#a87ff25ad98e9fa481e6f64247d7aba4d">gg::EventDispatcher::EventDispatcher</a></div><div class="ttdeci">EventDispatcher(EventDispatcher &amp;&amp;)=delete</div></div>
<div class="ttc" id="aclassgg_1_1EventDispatcher_html_aa2ac8a84c686abe1e1d1319e82221ed7"><div class="ttname"><a href="classgg_1_1EventDispatcher.html#aa2ac8a84c686abe1e1d1319e82221ed7">gg::EventDispatcher::Unsubscribe</a></div><div class="ttdeci">static void Unsubscribe(IEventSubscriber *s, const EventType e)</div></div>
<div class="ttc" id="aclassgg_1_1EventDispatcher_html_ab0f8028199ca3b02d37f642ac24e6e53"><div class="ttname"><a href="classgg_1_1EventDispatcher.html#ab0f8028199ca3b02d37f642ac24e6e53">gg::EventDispatcher::GetInstance</a></div><div class="ttdeci">static auto GetInstance() -&gt; EventDispatcher &amp;</div><div class="ttdef"><b>Definition:</b> Event.hpp:92</div></div>
<div class="ttc" id="aclassgg_1_1EventDispatcher_html_ab3245f7372c0d5384580f75c0ce2301b"><div class="ttname"><a href="classgg_1_1EventDispatcher.html#ab3245f7372c0d5384580f75c0ce2301b">gg::EventDispatcher::CheckSubscriberExistence</a></div><div class="ttdeci">friend bool CheckSubscriberExistence(IEventSubscriber *e)</div></div>
<div class="ttc" id="aclassgg_1_1EventDispatcher_html_ac0c4379683c748e569a9fa6be55bab55"><div class="ttname"><a href="classgg_1_1EventDispatcher.html#ac0c4379683c748e569a9fa6be55bab55">gg::EventDispatcher::NotifySubscribers</a></div><div class="ttdeci">static void NotifySubscribers(IEvent *e)</div></div>
<div class="ttc" id="aclassgg_1_1EventDispatcher_html_ad509264c69cbbbace55964f563d7d0d8"><div class="ttname"><a href="classgg_1_1EventDispatcher.html#ad509264c69cbbbace55964f563d7d0d8">gg::EventDispatcher::operator=</a></div><div class="ttdeci">auto operator=(const EventDispatcher &amp;) -&gt; EventDispatcher &amp;=delete</div></div>
<div class="ttc" id="aclassgg_1_1IEventSubscriber_html"><div class="ttname"><a href="classgg_1_1IEventSubscriber.html">gg::IEventSubscriber</a></div><div class="ttdef"><b>Definition:</b> Event.hpp:59</div></div>
<div class="ttc" id="aclassgg_1_1IEventSubscriber_html_a08c9dd34d285004445b619fe55a064f6"><div class="ttname"><a href="classgg_1_1IEventSubscriber.html#a08c9dd34d285004445b619fe55a064f6">gg::IEventSubscriber::OnEvent</a></div><div class="ttdeci">virtual void OnEvent(IEvent *e)</div><div class="ttdef"><b>Definition:</b> Event.hpp:66</div></div>
<div class="ttc" id="aclassgg_1_1IEventSubscriber_html_a08d412b35e08386f265840cd3652c8fc"><div class="ttname"><a href="classgg_1_1IEventSubscriber.html#a08d412b35e08386f265840cd3652c8fc">gg::IEventSubscriber::IEventSubscriber</a></div><div class="ttdeci">IEventSubscriber()=default</div></div>
<div class="ttc" id="aclassgg_1_1IEventSubscriber_html_a574e684bfb29123ae250769873231cd8"><div class="ttname"><a href="classgg_1_1IEventSubscriber.html#a574e684bfb29123ae250769873231cd8">gg::IEventSubscriber::~IEventSubscriber</a></div><div class="ttdeci">virtual ~IEventSubscriber()=default</div></div>
<div class="ttc" id="aclassgg_1_1IEventSubscriber_html_a961a23b00ee141313a4c8f7a505f3cb8"><div class="ttname"><a href="classgg_1_1IEventSubscriber.html#a961a23b00ee141313a4c8f7a505f3cb8">gg::IEventSubscriber::GetNumberOfSubscribedEvents</a></div><div class="ttdeci">auto GetNumberOfSubscribedEvents() const -&gt; size_t</div></div>
<div class="ttc" id="aclassgg_1_1IEventSubscriber_html_ac8aebcb4316a65f73f794a924e5619ee"><div class="ttname"><a href="classgg_1_1IEventSubscriber.html#ac8aebcb4316a65f73f794a924e5619ee">gg::IEventSubscriber::operator==</a></div><div class="ttdeci">auto operator==(const IEventSubscriber &amp;) -&gt; bool</div></div>
<div class="ttc" id="aclassgg_1_1IEvent_html"><div class="ttname"><a href="classgg_1_1IEvent.html">gg::IEvent</a></div><div class="ttdef"><b>Definition:</b> Event.hpp:41</div></div>
<div class="ttc" id="aclassgg_1_1IEvent_html_a0154647492980621230ab6cdc3b3080b"><div class="ttname"><a href="classgg_1_1IEvent.html#a0154647492980621230ab6cdc3b3080b">gg::IEvent::GetEventType</a></div><div class="ttdeci">virtual auto GetEventType() const -&gt; EventType=0</div></div>
<div class="ttc" id="aclassgg_1_1IEvent_html_acbf64dbf915a0e0d66bce214266f8ac4"><div class="ttname"><a href="classgg_1_1IEvent.html#acbf64dbf915a0e0d66bce214266f8ac4">gg::IEvent::~IEvent</a></div><div class="ttdeci">virtual ~IEvent()=default</div></div>
<div class="ttc" id="aclassgg_1_1TimePassed_html"><div class="ttname"><a href="classgg_1_1TimePassed.html">gg::TimePassed</a></div><div class="ttdef"><b>Definition:</b> TimeEvent.hpp:13</div></div>
<div class="ttc" id="anamespacegg_html"><div class="ttname"><a href="namespacegg.html">gg</a></div><div class="ttdef"><b>Definition:</b> Application.hpp:22</div></div>
<div class="ttc" id="anamespacegg_html_a03e8c24de531dd717d01d59ca2dc6f93"><div class="ttname"><a href="namespacegg.html#a03e8c24de531dd717d01d59ca2dc6f93">gg::CheckSubscriberExistence</a></div><div class="ttdeci">bool CheckSubscriberExistence(IEventSubscriber *e)</div></div>
<div class="ttc" id="anamespacegg_html_a98db2e09803bf503c02d952e6a8840f4"><div class="ttname"><a href="namespacegg.html#a98db2e09803bf503c02d952e6a8840f4">gg::EventCategory</a></div><div class="ttdeci">EventCategory</div><div class="ttdef"><b>Definition:</b> Event.hpp:31</div></div>
<div class="ttc" id="anamespacegg_html_a98db2e09803bf503c02d952e6a8840f4a0a6e5fa84fb8c3d2c01f29f51f7d56ae"><div class="ttname"><a href="namespacegg.html#a98db2e09803bf503c02d952e6a8840f4a0a6e5fa84fb8c3d2c01f29f51f7d56ae">gg::EventCategory::EventDestroying</a></div><div class="ttdeci">@ EventDestroying</div></div>
<div class="ttc" id="anamespacegg_html_a98db2e09803bf503c02d952e6a8840f4a6e700fb918edc200030d12664aca3b6b"><div class="ttname"><a href="namespacegg.html#a98db2e09803bf503c02d952e6a8840f4a6e700fb918edc200030d12664aca3b6b">gg::EventCategory::EventBuilding</a></div><div class="ttdeci">@ EventBuilding</div></div>
<div class="ttc" id="anamespacegg_html_a98db2e09803bf503c02d952e6a8840f4a6fa566508cafa0ce4b09501f0c6946f1"><div class="ttname"><a href="namespacegg.html#a98db2e09803bf503c02d952e6a8840f4a6fa566508cafa0ce4b09501f0c6946f1">gg::EventCategory::EventTerraforming</a></div><div class="ttdeci">@ EventTerraforming</div></div>
<div class="ttc" id="anamespacegg_html_a98db2e09803bf503c02d952e6a8840f4ac89686a387d2b12b3c729ce35a0bcb5b"><div class="ttname"><a href="namespacegg.html#a98db2e09803bf503c02d952e6a8840f4ac89686a387d2b12b3c729ce35a0bcb5b">gg::EventCategory::Window</a></div><div class="ttdeci">@ Window</div></div>
<div class="ttc" id="anamespacegg_html_ada69b9f844678d00cd5c2b2c30a20122"><div class="ttname"><a href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122">gg::EventType</a></div><div class="ttdeci">EventType</div><div class="ttdef"><b>Definition:</b> Event.hpp:11</div></div>
<div class="ttc" id="anamespacegg_html_ada69b9f844678d00cd5c2b2c30a20122a0c727a782f5704f3020d6831cfcc1ed1"><div class="ttname"><a href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a0c727a782f5704f3020d6831cfcc1ed1">gg::EventType::MousePressed</a></div><div class="ttdeci">@ MousePressed</div></div>
<div class="ttc" id="anamespacegg_html_ada69b9f844678d00cd5c2b2c30a20122a32b46f19c07697307b7935a700c82b8f"><div class="ttname"><a href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a32b46f19c07697307b7935a700c82b8f">gg::EventType::KeyboardReleased</a></div><div class="ttdeci">@ KeyboardReleased</div></div>
<div class="ttc" id="anamespacegg_html_ada69b9f844678d00cd5c2b2c30a20122a33bd071d891ee2f9147b76a58d18d554"><div class="ttname"><a href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a33bd071d891ee2f9147b76a58d18d554">gg::EventType::MouseReleased</a></div><div class="ttdeci">@ MouseReleased</div></div>
<div class="ttc" id="anamespacegg_html_ada69b9f844678d00cd5c2b2c30a20122a4dd32204c0f6c88a76b95591fffc7ee1"><div class="ttname"><a href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a4dd32204c0f6c88a76b95591fffc7ee1">gg::EventType::TextInserted</a></div><div class="ttdeci">@ TextInserted</div></div>
<div class="ttc" id="anamespacegg_html_ada69b9f844678d00cd5c2b2c30a20122a6360c775f2c9e4b01a927410726dff09"><div class="ttname"><a href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a6360c775f2c9e4b01a927410726dff09">gg::EventType::KeyboardPressed</a></div><div class="ttdeci">@ KeyboardPressed</div></div>
<div class="ttc" id="anamespacegg_html_ada69b9f844678d00cd5c2b2c30a20122a6adf97f83acf6453d4a6a4b1070f3754"><div class="ttname"><a href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a6adf97f83acf6453d4a6a4b1070f3754">gg::EventType::None</a></div><div class="ttdeci">@ None</div></div>
<div class="ttc" id="anamespacegg_html_ada69b9f844678d00cd5c2b2c30a20122a9c130e95620950534eee656031fc6a12"><div class="ttname"><a href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a9c130e95620950534eee656031fc6a12">gg::EventType::ButtonClicked</a></div><div class="ttdeci">@ ButtonClicked</div></div>
<div class="ttc" id="anamespacegg_html_ada69b9f844678d00cd5c2b2c30a20122a9f8f27bff2915738c4fe1b970e12f89c"><div class="ttname"><a href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122a9f8f27bff2915738c4fe1b970e12f89c">gg::EventType::WindowResize</a></div><div class="ttdeci">@ WindowResize</div></div>
<div class="ttc" id="anamespacegg_html_ada69b9f844678d00cd5c2b2c30a20122abe3914d0f55bc3f12bdefcf7fb799bab"><div class="ttname"><a href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122abe3914d0f55bc3f12bdefcf7fb799bab">gg::EventType::TestEvent</a></div><div class="ttdeci">@ TestEvent</div></div>
<div class="ttc" id="anamespacegg_html_ada69b9f844678d00cd5c2b2c30a20122ac2770ad109c8063ce69a3608a9a16c08"><div class="ttname"><a href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122ac2770ad109c8063ce69a3608a9a16c08">gg::EventType::MouseMoved</a></div><div class="ttdeci">@ MouseMoved</div></div>
<div class="ttc" id="anamespacegg_html_ada69b9f844678d00cd5c2b2c30a20122ac984201d37197ab297a14d19efee4b07"><div class="ttname"><a href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122ac984201d37197ab297a14d19efee4b07">gg::EventType::WindowClose</a></div><div class="ttdeci">@ WindowClose</div></div>
<div class="ttc" id="anamespacegg_html_ada69b9f844678d00cd5c2b2c30a20122ad7581f38211da778a489922e48b6d78c"><div class="ttname"><a href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122ad7581f38211da778a489922e48b6d78c">gg::EventType::ToggleButtonClicked</a></div><div class="ttdeci">@ ToggleButtonClicked</div></div>
<div class="ttc" id="anamespacestd_html"><div class="ttname"><a href="namespacestd.html">std</a></div><div class="ttdef"><b>Definition:</b> Event.hpp:84</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
